package org.drools.project.model;

import org.drools.model.Model;
import org.kie.api.builder.ReleaseId;
import org.drools.compiler.kproject.ReleaseIdImpl;

public class ProjectModel implements org.drools.modelcompiler.CanonicalKieModuleModel {

    @Override
    public String getVersion() {
        return "0.7.0";
    }

    @Override
    public java.util.List<Model> getModels() {
        return java.util.Arrays.asList(new org.drools.simple.candrink.Rules7D65E6640E56F94738E0014B02ED63FD(), new org.drools.simple.declaredtypes.RulesE03C5573C4F66E0F0FF35D14290A3361(), new org.drools.simple.project.RulesBB649E8CBC0B16AFA168BF54BB8C44FF());
    }

    public java.util.List<Model> getModelsForKieBase(String kieBaseName) {
        switch (kieBaseName) {
            case "canDrinkWithTypesKB": return getModels();
            case "simpleKB": return getModels();
            case "canDrinkKB": return getModels();
        }
        throw new IllegalArgumentException("Unknown KieBase: " + kieBaseName);
    }

    @Override
    public ReleaseId getReleaseId() {
        return new ReleaseIdImpl("dummy", "dummy", "0.0.0");
    }

@Override()
public org.kie.api.builder.model.KieModuleModel getKieModuleModel() {
    org.kie.api.builder.model.KieModuleModel kModuleModel = org.kie.api.KieServices.get().newKieModuleModel();
    org.kie.api.builder.model.KieBaseModel kieBaseModel_canDrinkWithTypesKB = kModuleModel.newKieBaseModel("canDrinkWithTypesKB");
    kieBaseModel_canDrinkWithTypesKB.setEventProcessingMode(org.kie.api.conf.EventProcessingOption.CLOUD);
    kieBaseModel_canDrinkWithTypesKB.addPackage("org.drools.simple.declaredtypes");
    kieBaseModel_canDrinkWithTypesKB.setSessionsPool(org.kie.api.conf.SessionsPoolOption.get(1));
    org.kie.api.builder.model.KieSessionModel kieSessionModel_canDrinkWithTypesKS = kieBaseModel_canDrinkWithTypesKB.newKieSessionModel("canDrinkWithTypesKS");
    kieSessionModel_canDrinkWithTypesKS.setType(org.kie.api.builder.model.KieSessionModel.KieSessionType.STATEFUL);
    kieSessionModel_canDrinkWithTypesKS.setClockType(org.kie.api.runtime.conf.ClockTypeOption.get("realtime"));
    org.kie.api.builder.model.KieBaseModel kieBaseModel_simpleKB = kModuleModel.newKieBaseModel("simpleKB");
    kieBaseModel_simpleKB.setEventProcessingMode(org.kie.api.conf.EventProcessingOption.CLOUD);
    kieBaseModel_simpleKB.addPackage("org.drools.simple.project");
    org.kie.api.builder.model.KieSessionModel kieSessionModel_simpleKS = kieBaseModel_simpleKB.newKieSessionModel("simpleKS");
    kieSessionModel_simpleKS.setDefault(true);
    kieSessionModel_simpleKS.setType(org.kie.api.builder.model.KieSessionModel.KieSessionType.STATEFUL);
    kieSessionModel_simpleKS.setClockType(org.kie.api.runtime.conf.ClockTypeOption.get("realtime"));
    org.kie.api.builder.model.KieBaseModel kieBaseModel_canDrinkKB = kModuleModel.newKieBaseModel("canDrinkKB");
    kieBaseModel_canDrinkKB.setEventProcessingMode(org.kie.api.conf.EventProcessingOption.CLOUD);
    kieBaseModel_canDrinkKB.addPackage("org.drools.simple.candrink");
    org.kie.api.builder.model.KieSessionModel kieSessionModel_canDrinkKS = kieBaseModel_canDrinkKB.newKieSessionModel("canDrinkKS");
    kieSessionModel_canDrinkKS.setType(org.kie.api.builder.model.KieSessionModel.KieSessionType.STATEFUL);
    kieSessionModel_canDrinkKS.setClockType(org.kie.api.runtime.conf.ClockTypeOption.get("realtime"));
    return kModuleModel;
}
}